module Esplanade
  class Response
    class Doc
      def initialize(request, raw)
        @request = request
        @raw = raw
      end

      def tomogram
        @tomogram ||= @request.doc.responses.find_all { |response| response['status'] == @raw.status }
        raise NotDocumented.new(**message) if @tomogram == []

        @tomogram
      rescue Esplanade::Request::PrefixNotMatch
        raise PrefixNotMatch.new(**message)
      end

      def json_schemas
        @json_schemas ||= tomogram.map { |action| action['body'] }
      end

      def status
        @status ||= tomogram['status']
      end

      private

      def message
        {
          request: {
            method: @request.raw.method,
            raw_path: @request.raw.raw_path,
            path: @request.raw.path
          },
          status: @raw.status
        }
      end
    end
  end
end
